//Move a sprite using the keys...

#include <PA9.h>
#include "thmenu.h"

#include "thgoodness.h"
//#include "thbullets.h"

#include "thdualsprites.h"

// PAGfx Include
#include "gfx/all_gfx.c"
#include "gfx/all_gfx.h"

#include "nitrofs.h"
#include <sys/stat.h>
#include <sys/dir.h>
#include <fat.h>

//Fonction principale du code
int main(void){
	u32 frame=0;	//frame counter
	PA_Init(); //Initialision of PAlib
	PA_InitVBL();
	PA_InitText(0,0);	
	PA_InitText(1,0);
	PA_InitSound(); 	// Sound Init, for the mod player...
//	SndInit9();
//	void *pool;
//	pool=malloc(59716);
//	SndSetMemPool(pool, 59716);
	PA_InitRand();
	rotsetInit();
	//Since we initalized everything lets display the menu
/* this block of code was used to test thSprite lib
	int thsp=thSpriteCreate((void*)marisa0_Sprite,OBJ_SIZE_64X64,64,0,96,64,-1);
	int x=120;
	int y=64;
	int yinc=100;
	int xinc=3;
	thSpriteDestroy(thsp);
	do {
		thSpriteDiag();
		PA_WaitForVBL();
	}while(--yinc!=0);
	thsp=thSpriteCreate((void*)marisa0_Sprite,OBJ_SIZE_64X64,64,0,22,180,-1);
	thsp=thSpriteCreate((void*)marisa0_Sprite,OBJ_SIZE_64X64,64,0,120,64,-1);
	while(1) {
		thSpriteSetXY(thsp,x,y);
		y+=yinc;
		x+=xinc;
		if(x>310) xinc=-3;
		if(x<-70) xinc=4;
		if(y>500) yinc=-3;
		if(y<-250) yinc=5;
		PA_OutputText(0, 4, 0, "x: %d y: %d     ",x,y);
		thSpriteDiag();
		PA_WaitForVBL();
	}
*/
	//Girls do their best now and are preparing....
	PA_EasyBgLoad(0, 1, watchwarmly);	//load bottom screen bg 
	PA_EasyBgLoad(1, 1, titlescreen);	//top menu screen bg
	fatInitDefault();
	nitroFSInit("thds01.nds");

	//create spinny thing for splash screen
//	PA_OutputSimpleText(0, 0, 19, "Girls do their best now and are preparing");
//	PA_OutputSimpleText(0, 0, 21, "Please watch warmly till it is  ready."); 
	PA_DualLoadSpritePal(0, (void*)moonp_Pal);
 	PA_CreateSprite(0,0,(void*)menumoon_Sprite, OBJ_SIZE_64X64,1, 0, 180,128); 
	PA_SetSpritePrio(0, 0, 1);
	PA_SetSpriteMode(0, // Screen
	 		 0, // Sprite
			 1); // Alphablending
	PA_EnableSpecialFx(0, // Screen
			   SFX_ALPHA, // Alpha blending mode
			   0, // Nothing
			   SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_BD); // Everything normal
	PA_SetSFXAlpha(0, // Screen
			7, // Alpha level, 0-15
			15); // Leave this to 15 
	PA_EnableSpecialFx(1, // Screen
			   SFX_ALPHA, // Alpha blending mode
			   0, // Nothing
			   SFX_BG0 | SFX_BG1 | SFX_BG2 | SFX_BG3 | SFX_BD); // Everything normal
	PA_SetSFXAlpha(1, // Screen
			7, // Alpha level, 0-15
			15); // Leave this to 15 
	PA_SetSpriteRotEnable(0, 0, 0);                 
/*
	FILE *fp;
	char buff[11];
	int len;
	PA_OutputText(0, 0, 12, " file opened: %d",(fp=fopen("nitro:test.txt", "rb+")));
	if(fp) {
		buff[10]=0;
		len=fread(buff,10,1,fp);	
		PA_OutputText(0, 0, 13, " data! %d %s",len,buff);
		len=fread(buff,10,1,fp);	
		PA_OutputText(0, 0, 14, " data! %d %s",len,buff);
	}
*/
/*
	struct stat st;
	char filename[256]; // to hold a full filename and string terminator
	DIR_ITER* dir;
	int dcnt=0;
	dir = diropen ("nitro:/"); 
	if (dir == NULL) {
		PA_OutputText(0, 0, 13,"Unable to open the directory.\n");
	} else {
		while (dirnext(dir, filename, &st) == 0) {
			// st.st_mode & S_IFDIR indicates a directory
//			iprintf ("%s: %s\n", (st.st_mode & S_IFDIR ? " DIR" : "FILE"), filename);
			PA_OutputText(0, 0, 12+dcnt,"%d %s: %s %d\n",dcnt,(st.st_mode & S_IFDIR ? " DIR" : "FILE"), filename,st.st_size);
			dcnt++;
		}
	}
	dirclose(dir);
*/

	while((++frame)<350) {
		PA_WaitForVBL();
		PA_SetRotsetNoZoom(0, 0, // rotset
			   (frame<<2)&511); // angle, from 0 to 511
		if(Pad.Newpress.B) frame=350;
	}
		PA_SetRotsetNoZoom(0, 0, // rotset
			   0); // angle, from 0 to 511

	PA_DeleteSprite(0,0); //were done with that...
	PA_DeleteBg(0,1);
	PA_DeleteBg(1,1);
	//now we get serious, load the pallets

	PA_DualLoadSpritePal(FAMPAL,(void*)fampalp_Pal);	// Palette name
	PA_DualLoadSpritePal(MENUTXTPAL,(void*)menutxtp_Pal);	// Palette name (NOTE THIS IS USED LATER)
	PA_DualLoadSpritePal(DIALOGPAL,(void*)dialogp_Pal);	// 
	while (1) {	//all the way thru the menu loop :D

		thSpriteInit(); //(re)setup our sprite system
		thMenu();
//		PA_ResetBgSysScreen(0);		//clue tho !
//		PA_ResetBgSysScreen(1);	//will fix0r bg corruption?
		thGameStart(0,0,0,1);
	}
	return 0;
}
