#include "thgoodness.h" 
#include "gfx/all_gfx.h"
#include "marisaspells.h"
//#include "thmenu.h"
//#include "modfile.h"  // Include the mod file (the .mod file is in the data dir)
//#include "piano.h"
//#include "sailor.h"
//#include "Th04_01.h"
//#include "th4_024.h"
//#include "th4_024_2.h"
// for most of the structs used here...


//a player character 
Character bluemarisachr = 	{
		"Blue Marisa",	//character name
		"Another Witch on a broomstick",	//character description
		(void*)bluemarisa_Sprite, 	//forground sprites (yes plural!) to use
		(void*)NULL,	//background sprite to use
		(void*)bluemarisap_Pal,	//pallet
		600,			//bg rotation speed
		5,			//hitbox size
		23,			//graze size (unused on enemys)
		700,			//unfocused speed
		310,			//focused speed (these have diff use on enemys)
		CCLASS_PLYR,		//what class 
		0,			//How much im worth to kill (not used on player chars)
		playerGrimoire,		//spells this character can use	(on players the spells will be used ofc for spell bombs) 
		NULL,		//dialog (note only enemy characters have dialog, tho i guess the char dialog could be the 'ending'... :D
		(void*)bluemarisabullet_Sprite
};

//mm this looks familiar :P (as in it is a familiar)
Character fam1chr = 	{
		"angelsan with octagram",	//character name
		"a familiar desc",	//character description
		(void*)angelsan32x32_Sprite, 	//forground sprites (yes plural!) to use
		(void*)octagram64x64_Sprite,	//background sprite to use
		(void*)fampalp_Pal,	//pallet
		-600,			//rotation speed
		20,			//hitbox size
		0,			//graze size (unused on enemys)
		3000,			//unfocused  focused health
		900,			//focused (how much health a hit from player's bullet will take off with each type of hit :P)
		CCLASS_FAMILIAR,		//what class 
		1234,			//How much im worth to kill
		fam1grimoire,		//spells this character can use	(on players the spells will be used ofc for spell bombs)
		NULL,		//dialog (note only enemy characters have dialog, tho i guess the char dialog could be the 'ending'... :D
		(void*)fambullet16x16_Sprite
};


//another familiar
Character angelsan = 	{
		"angelsan",	//character name
		"just the angel",	//character description
		(void*)angelsan32x32_Sprite, 	//forground sprites (yes plural!) to use
		(void*)NULL,	//background sprite to use
		(void*)fampalp_Pal,	//pallet
		-600,			//rotation speed
		12,			//hitbox size
		0,			//graze size (unused on enemys)
		10000,			//unfocused  focused health
		8000,			//focused (how much health a hit from player's bullet will take off with each type of hit :P)
		CCLASS_FAMILIAR,		//what class 
		400,			//How much im worth to kill
		fam2grimoire,		//spells this character can use	(on players the spells will be used ofc for spell bombs)
		NULL,		//dialog (note only enemy characters have dialog, tho i guess the char dialog could be the 'ending'... :D
		(void*)fambullet8x8_Sprite
};


//#define WAIT2DIE -1

//need like STAGE_WAITHEALTH where it halts script till health <= given value

struct StageSteps ezStage1[] = {
//	{EVENT TYPE, 	wait,   index, char,		entity,	x,	y)   was previously:	type CHARACTER,NDX, Who,	WAIT, x, y}


//
	{STAGE_BG,	0,	0,	NOCHR,	  	0,	0, 	0},	//Start this stages background (bg 1 from list)
	{STAGE_BGM,	75,	2,	NOCHR,		0,	0,	0},	//Start this stages  bgm (song 2 from playlist)

	{STAGE_SHOWLVL,	320,	0,	NOCHR,		0,	0,	0},
	{STAGE_SUMMON,	0,	0,	&fam1chr,	1,	-32,	0},	//start noodles
	{STAGE_SUMMON,	0,	0,	&fam1chr,	2,	288,	20},	
	{STAGE_SPELLCAST,268,	5,	&fam1chr,	1,	0,	0},
	{STAGE_SPELLCAST,280,	6,	&fam1chr,	2,	0,	0},

	{STAGE_SUMMON,	0,	0,	&fam1chr,	3,	-32,	80},	
	{STAGE_SPELLCAST,270,	7,	&fam1chr,	3,	0,	0},

	{STAGE_BANISH,0,	0,	NOCHR,		1,	0,	0},
	{STAGE_BANISH,50,	0,	NOCHR,		2,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		3,	0,	0},



	{STAGE_SUMMON,	0,	0,	&fam1chr,	3,	199,	-31},	
	{STAGE_SUMMON,	0,	0,	&fam1chr,	4,	-32,	50},	
	{STAGE_SPELLCAST,200,	5,	&fam1chr,	3,	0,	0},
	{STAGE_SPELLCAST,400,	1,	&fam1chr,	4,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		3,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		4,	0,	0},

	{STAGE_SUMMON,	0,	0,	&angelsan,	1,	90,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	2,	120,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	3,	255,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	4,	7,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	5,	26,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	6,	177,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	7,	200,	-31},	

	{STAGE_SPELLCAST,35,	0,	&angelsan,	1,	0,	0},
	{STAGE_SPELLCAST,35,	0,	&angelsan,	2,	0,	0},
	{STAGE_SPELLCAST,35,	0,	&angelsan,	3,	0,	0},
	{STAGE_SPELLCAST,50,	0,	&angelsan,	4,	0,	0},

	{STAGE_SPELLCAST,35,	1,	&angelsan,	5,	0,	0},
	{STAGE_SPELLCAST,35,	1,	&angelsan,	6,	0,	0},
	{STAGE_SPELLCAST,35,	1,	&angelsan,	7,	0,	0},
	{STAGE_SUMMON,	0,	0,	&fam1chr,	8,	128,	96},	

	{STAGE_SPELLCAST,360,	6,	&fam1chr,	8,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		1,	0,	0},
	{STAGE_SUMMON,	0,	0,	&fam1chr,	1,	128,	0},	
	{STAGE_SPELLCAST,140,	7,	&fam1chr,	1,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		3,	0,	0},
	{STAGE_SUMMON,	40,	0,	&fam1chr,	3,	60,	96},	
	{STAGE_BANISH,0,	0,	NOCHR,		2,	0,	0},

	{STAGE_SUMMON,	0,	0,	&fam1chr,	2,	-32,	0},	
	{STAGE_SPELLCAST,200,	5,	&fam1chr,	3,	0,	0},

	{STAGE_BANISH,300,	0,	NOCHR,		2,	0,	0},

	{STAGE_BANISH,0,	0,	NOCHR,		3,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		4,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		5,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		6,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		7,	0,	0},
	{STAGE_BANISH,00,	0,	NOCHR,		8,	0,	0},
	{STAGE_SUMMON,	0,	0,	&angelsan,	3,	255,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	4,	7,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	5,	26,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	6,	177,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	7,	200,	-31},
	{STAGE_SUMMON,	0,	0,	&angelsan,	8,	200,	-31},		
	{STAGE_SPELLCAST,35,	3,	&angelsan,	3,	128,	96},
	{STAGE_SPELLCAST,50,	3,	&angelsan,	4,	128,	60},
	{STAGE_SPELLCAST,45,	3,	&angelsan,	5,	128,	70},
	{STAGE_SPELLCAST,45,	2,	&angelsan,	6,	129,	80},
	{STAGE_SPELLCAST,45,	2,	&angelsan,	7,	128,	90},
	{STAGE_SPELLCAST,45,	2,	&angelsan,	8,	128,	90},

	{STAGE_BANISH,400,	0,	NOCHR,		1,	0,	0},

	{STAGE_SUMMON,	120,	0,	&marisachr,	1,	288,	50},	//enter's marisa \^_^/
	{STAGE_ENTITYMOVE, 80,	80,	NULL,		1,	128,	60},	//exits marisa
	{STAGE_ENTITYSTOP, 0,	0,	NULL,		1,	0,	0},

	{STAGE_DIALOG,10,	0,	&marisachr,	0,	0,	0},
//	{STAGE_BGMSTOP,	500,	0,	NOCHR,		0,	0,	0},	//Stop bgm
	{STAGE_BG,	500,	1,	NOCHR,	  	0,	0, 	0},
	{STAGE_HALT,	1,	0,	NOCHR,		0,	0,	0},	//wait must be non zero!
//	{STAGE_BANISH,WAIT2DIE,	0,	NOCHR,		3,	0,	0},
//	{STAGE_BANISH,WAIT2DIE,	0,	NOCHR,		4,	0,	0}, //wait2die has issues atm ~_~
	{STAGE_CLEARGFLAGS,0,	GFLAGS_PSAFE,	NOCHR,		0,	0,	0},
	{STAGE_CLEARGFLAGS,10,	GFLAGS_PSAFE,	NOCHR,		0,	0,	0},


//	{STAGE_BG,	00,	1,	NOCHR,	  	0,	0, 	0},


//marisa go here:
	{STAGE_BGM,	190,	3,	NOCHR,		0,	0,	0},	//Start second bgm (music/bg needs to be set in dialog as well hmmmz) mebbe have a thStageGetNext that will run the next steps with 0 wait up till another wait2die?? 
///	{STAGE_SUMMON,	0,	0,	&fam1chr,	3,	288,	30},	
//	{STAGE_SPELLCAST,140,	3,	&fam1chr,	3,	0,	0},

//	{STAGE_SUMMON,	120,	0,	&marisachr,	1,	128,	50},	//enter's marisa \^_^/
//	{STAGE_SPELLCAST,1000,	1,	NULL,	1,	0,	0},	

	//put these two before start of 'spell group'
	{STAGE_STRTSPLGRP,0,	0,	NULL,	0,	0,	0},


	{STAGE_SPELLCAST,240,	6,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,30,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLCAST,60,	7,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,120,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLCAST,240,	6,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,30,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLCAST,60,	7,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,240,	0,	NULL,		1,	0,	0},

	{STAGE_SPELLCAST,150,	2,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,60,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLCAST,300,	8,	NULL,	1,	0,	0},	


	{STAGE_SPELLRESUME,150,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLPAUSE,20,	0,	NULL,		1,	0,	0},

	{STAGE_SPELLRESUME,320,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLPAUSE,20,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLRESUME,480,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLPAUSE,150,	0,	NULL,		1,	0,	0},
//	{STAGE_SPELLRESUME,220,	0,	NULL,		1,	0,	0},
//	{STAGE_SPELLPAUSE,155,	0,	NULL,		1,	0,	0},

	{STAGE_ENDSPLGRP,0,	0,	NULL,	0,	0,	0},	//print totals

	{STAGE_ENTITYSTOP, 5,	0,	NULL,		1,	0,	0},
	{STAGE_ENTITYMOVE, 0,	250,	NULL,		1,	500,	30},	//exits marisa
	{STAGE_SUMMON,	0,	0,	&angelsan,	3,	255,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	4,	7,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	5,	26,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	6,	177,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	7,	200,	-31},
	{STAGE_SUMMON,	0,	0,	&angelsan,	8,	200,	-31},		
	{STAGE_SPELLCAST,0,	3,	&angelsan,	3,	128,	96},
	{STAGE_SPELLCAST,50,	3,	&angelsan,	4,	128,	60},
	{STAGE_SPELLCAST,45,	3,	&angelsan,	5,	128,	70},
	{STAGE_SPELLCAST,45,	2,	&angelsan,	6,	129,	80},
	{STAGE_SPELLCAST,45,	2,	&angelsan,	7,	128,	90},
	{STAGE_SPELLCAST,400,	2,	&angelsan,	8,	128,	90},
	{STAGE_BANISH,00,	0,	NOCHR,		1,	0,	0},	//Make sure marisa is gone before:

	{STAGE_SUMMON,	0,	0,	&marisachr,	1,	200,	-32},	//re-enter's marisa \^_^/
	{STAGE_ENTITYMOVE, 30,	30,	NULL,		1,	128,	50},	//repositions marisa.... 
	{STAGE_ENTITYSTOP, 1,	0,	NULL,		1,	0,	0},	//note how it stops her after exact time to move, neat eh?
	{STAGE_SPELLPAUSE,38,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLCAST,738,	3,	NULL,	1,	0,	0},	
	{STAGE_BGM,	60,	4,	NOCHR,		0,	0,	0},	//HACK CAUSE MUSIC GETS CURRUPTED :////
	{STAGE_SPELLCAST,60,	7,	NULL,	1,	0,	0},	//BURST!

	{STAGE_BANISH,0,	0,	NOCHR,		3,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		4,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		5,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		6,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		7,	0,	0},
	{STAGE_BANISH,0,	0,	NOCHR,		8,	0,	0},


//	{STAGE_SPELLCAST,480,	4,	NULL,	1,	0,	0},	
	{STAGE_SPELLCAST,300,	5,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,120,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLCAST,160,	7,	NULL,	1,	0,	0},	//BURST!
	{STAGE_SPELLCAST,400,	1,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,30,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLRESUME,140,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLPAUSE,30,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLRESUME,130,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLPAUSE,60,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLCAST,30,	7,	NULL,	1,	0,	0},	//BURST!
	{STAGE_SPELLCAST,100,	9,	NULL,	1,	0,	0},	


	{STAGE_SUMMON,	0,	0,	&angelsan,	3,	255,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	4,	7,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	5,	26,	-31},	
	{STAGE_SUMMON,	0,	0,	&angelsan,	6,	177,	-31},	
	{STAGE_SPELLCAST,0,	3,	&angelsan,	3,	128,	96},
	{STAGE_SPELLCAST,50,	3,	&angelsan,	4,	128,	60},
	{STAGE_SPELLCAST,45,	3,	&angelsan,	5,	128,	70},
	{STAGE_SPELLCAST,0,	2,	&angelsan,	6,	129,	80},


//	{STAGE_ENTITYMOVE, 60,	20,	NULL,		1,	38,	50},	//repositions marisa.... 
//	{STAGE_ENTITYSTOP, 1,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLPAUSE,70,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLCAST,195,	6,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,30,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLCAST,60,	7,	NULL,	1,	0,	0},	
	{STAGE_BANISH,	0,	0,	&angelsan,	3,	255,	-31},	
	{STAGE_BANISH,	0,	0,	&angelsan,	4,	7,	-31},	
	{STAGE_BANISH,	0,	0,	&angelsan,	5,	26,	-31},	
	{STAGE_BANISH,	0,	0,	&angelsan,	6,	177,	-31},	

	{STAGE_SPELLPAUSE,120,	0,	NULL,		1,	0,	0},
	{STAGE_STRTSPLGRP,0,	0,	NULL,	0,	0,	0},

	{STAGE_SPELLCAST,40,	2,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,250,	0,	NULL,		1,	0,	0},

	{STAGE_SPELLRESUME,270,	0,	NULL,		1,	0,	0},
	{STAGE_SPELLPAUSE,160,	0,	NULL,		1,	0,	0},



	{STAGE_SPELLCAST,300,	7,	NULL,	1,	0,	0},	//BURST!


	{STAGE_SPELLCAST,1130,	10,	NULL,	1,	0,	0},	
	{STAGE_SPELLPAUSE,00,	0,	NULL,		1,	0,	0},
	{STAGE_ENDSPLGRP,0,	0,	NULL,	0,	0,	0},	//print totals
	{STAGE_BOSSDEATH,150,	0,	NULL,	1,	0,	0},	//do death sequence
	{STAGE_BANISH,	800,	0,	NULL,	1,	0,	0},	//get rid of boss
	
	{STAGE_FINISH,	300,	0,	NOCHR, 	  	0,	0,	300},	//Player made it till the end!!

};

struct Stage ezScenario[]={                                 //
	{(void*)stage1gfx_Sprite,"A Tumbly World....        What am i supposed to do here?",ezStage1}, //stage 1 
	{(void*)stage1gfx_Sprite," just here for illustrative purposes.. Really same as stage1!",ezStage1},  //stage 2
//	{"stage2","mystic stage two txt",ezStage2},
//	{"stage3","mystic stage 3 txt",ezStage3},
	{NULL,NULL,NULL}
};
