#include <PA9.h>
#include "gfx/all_gfx.h"
#include "thgoodness.h"
#include "thdialog.h"

struct thDialog *thDialogPtr;
int thDiaCnt=0;
int thDiaNdx;
int thDiaBullets[2];	//
void *thDiaLastSp[2];	//last sprite used
int thDiaLast;	//last dialog came from who?

//this function just gets called on a transition, or a fresh dialog session
void thDialogCreateSprites(void) {
	struct bsprite_s menubull={OBJ_SIZE_64X64,DIALOGPAL,64,-1}; //this magicBullet could be global i guess -1 hitrad == no hit detect
	struct badv_s badv={-1,30,87,NULL,0,0,0}; // create advanced options bullet create struc
	int side,inc;
	if(thDiaLastSp[thDialogPtr[thDiaNdx].side]!=thDialogPtr[thDiaNdx].sprite) {
		thDiaLastSp[thDialogPtr[thDiaNdx].side]=thDialogPtr[thDiaNdx].sprite;
//		PA_DualLoadSpritePal(DIALOGPAL,(void*)largegalpal_Pal);	// Palette name (NOTE THIS IS USED LATER)
		if(thDialogPtr[thDiaNdx].sprite)	{
		//if ndx!=0 then delete the old ones plz first k?
			if(thDiaBullets[thDialogPtr[thDiaNdx].side]!=-1) { // move it off screen it'll kill itself (and others all follow!!) :D but first make sure we existed before

				if(thDialogPtr[thDiaNdx].side) {
					bulletsSetXinc(thDiaBullets[thDialogPtr[thDiaNdx].side],1000);
				} else {
					bulletsSetXinc(thDiaBullets[thDialogPtr[thDiaNdx].side],-1000);
				}

			}	
			if(thDialogPtr[thDiaNdx].side) {
				side=224+64;
				inc=0-573;
			} else {
				side=-32-64;
				inc=573;
			}

			//set who to 128+0 or 1 for side
			badv.follow=(thDiaBullets[thDialogPtr[thDiaNdx].side]=bulletCreate(thDialogPtr[thDiaNdx].sprite, &menubull, side,221-3, inc,0, -1,&badv,NULL,BULLET_WIDE,64+thDialogPtr[thDiaNdx].side)); 
	//Just to note keeping track of these seems redundant?
			bulletCreate((thDialogPtr[thDiaNdx].sprite)+4096, &menubull, side,    285,  0, 64, -1, &badv, NULL, BULLET_FOLLOW|BULLET_WIDE, 64+thDialogPtr[thDiaNdx].side);
			bulletCreate(thDialogPtr[thDiaNdx].sprite+8192, &menubull, side+64, 221, 64,  0, -1,&badv,NULL,BULLET_FOLLOW|BULLET_WIDE,64+thDialogPtr[thDiaNdx].side); 
			bulletCreate(thDialogPtr[thDiaNdx].sprite+12288, &menubull, side+64, 285, 64, 64, -1, &badv, NULL,  BULLET_FOLLOW|BULLET_WIDE, 64+thDialogPtr[thDiaNdx].side);
//	PA_OutputText(0, 2,8, "   lastside :%d",64+thDialogPtr[thDiaNdx].side);
		}
	}
}


#define DIALOGTXTDLY 20
//this dont NEED an argument
char thDialogUpdate(void) {
	if(thDialogPtr[thDiaNdx].text && (++thDiaCnt>=DIALOGTXTDLY)) 
		PA_BoxText(0, 1, 16, 30,19, thDialogPtr[thDiaNdx].text, thDiaCnt-DIALOGTXTDLY);
	if(((Pad.Newpress.A) && (thDiaCnt>60)) || (thDiaCnt>600)) {
		thEraseTxtArea(0,0, 16, 30, 19);
		if(thDialogPtr[thDiaNdx].text) {
			thDiaCnt=0;
			thDiaNdx++;
			if(!thDialogPtr[thDiaNdx].text) {
				if(thDiaBullets[0]!=-1) // isnt this cool?!?! one bullet goes off screen and outta existance and the rest follow :DDD
					bulletsSetXinc(thDiaBullets[0],1000);
				if(thDiaBullets[1]!=-1)
					bulletsSetXinc(thDiaBullets[1],-1000);
				bulletsSetAllWhoAlpha(64, 0); //set current to visable
				bulletsSetAllWhoAlpha(65, 0); //set current to visable
				return(0);
			}
			if(thDiaLast!=thDialogPtr[thDiaNdx].side) {
				bulletsSetAllWhoAlpha(64+thDiaLast, 1);	//set last sprite to alpha since were switching
				thDialogCreateSprites();
				bulletsSetAllWhoAlpha(64+thDialogPtr[thDiaNdx].side, 0); //set current to visable
			}
		}
		thDiaLast=thDialogPtr[thDiaNdx].side;
	}
	return(1);
}

//DAmn girl ur on top of this shit (i forgot i coded this funct already 2 days no sleep!! hehe) :D
void thDialogStart(struct thDialog *DialogPtr) {
	thDialogPtr=DialogPtr;
	thDiaCnt=0;	//used for 'typing text'
	thDiaNdx=0;	//used to tell where were at in the dialog
//	thDialog=DialogPoint
//	enemySafe=1; //stop enemy stuff (these should be macros :P)
	thDiaBullets[0]=-1;
	thDiaBullets[1]=-1;
	thDiaLast=0;
	thDiaLastSp[0]=NULL;
	thDiaLastSp[1]=NULL;
	thDialogCreateSprites();
	thDialogUpdate();
}

