#include <PA9.h>
#include <nds.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include "thsound.h"
#include "nitrofs.h"


//List of all game musics (used by both menu system's music room and stagescripts to select songs
const struct thBgmItems musicList[] = {
	{"Main Theme (piano.mod)","nitro:/piano.mod",0}, //these null should = a mod to play!
	{"Sailor of Time","nitro:/sailor.raw",11025},
	{"Lotus Land Story ","nitro:/Th04_01.raw",11025},
	{"Dreamy Pilot ","nitro:/th4_024.raw",11025},
	{"Dreamy Pilot2","nitro:/th4_024_2.raw",11025},
	{NULL,NULL,0}
};

//global to hold bgm music buffer ptr
u8 *sample=NULL;

//dunno where else this goes but menu?! nah
//Plays a song and returns ptr to title
const char *playSong(const struct thBgmItems *menu, int ndx) {
	PA_StopMod(); //incase on is already playing
	PA_StopSound(8);
	int fd;
	struct stat st;
	char ext[4];	
	fd=open(menu[ndx].filename,O_RDONLY);
	if(fd>0) {
		if(sample) free(sample);
		fstat(fd,&st);
		sample=malloc(st.st_size);
		if(sample) {
		read(fd,sample,st.st_size);
			strcpy(ext,menu[ndx].filename+(strlen(menu[ndx].filename)-3)); //get file extention
			if(strcmp(ext,"mod")==0) {
				PA_PlayMod(sample);
			} else {
				PA_PlaySoundEx2(8,sample,st.st_size,127,menu[ndx].rate,PA_SoundOption.format,1,0);
			}			
			close(fd);
		}
	}
	return menu[ndx].name; //in case u wanna display the title :P
};



