//Gfx converted using Mollusk's PAGfx Converter

//This file contains all the .h, for easier inclusion in a project

#ifndef ALL_GFX_H
#define ALL_GFX_H

#ifndef PAGfx_struct
    typedef struct{
    void *Map;
    int MapSize;
    void *Tiles;
    int TileSize;
    void *Palette;
    int *Info;
} PAGfx_struct;
#endif


// Sprite files : 
extern const unsigned char flandre_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char circle_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char bulle2_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char hibox_Sprite[64] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char batts_Sprite[1536] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char bulle3_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char god_Sprite[6144] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char godring_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char medic_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char godpaper_Sprite[2048] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char amu_Sprite[512] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal
extern const unsigned char bulle4_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : pal1_Pal

// Background files : 
extern const int bag3_Info[3]; // BgMode, Width, Height
extern const unsigned short bag3_Map[768] __attribute__ ((aligned (4))) ;  // Pal : bag3_Pal
extern const unsigned char bag3_Tiles[40384] __attribute__ ((aligned (4))) ;  // Pal : bag3_Pal
extern PAGfx_struct bag3; // background pointer

extern const int bag2_Info[3]; // BgMode, Width, Height
extern const unsigned short bag2_Map[768] __attribute__ ((aligned (4))) ;  // Pal : bag2_Pal
extern const unsigned char bag2_Tiles[14848] __attribute__ ((aligned (4))) ;  // Pal : bag2_Pal
extern PAGfx_struct bag2; // background pointer

extern const int bag1_Info[3]; // BgMode, Width, Height
extern const unsigned short bag1_Map[768] __attribute__ ((aligned (4))) ;  // Pal : bag1_Pal
extern const unsigned char bag1_Tiles[16384] __attribute__ ((aligned (4))) ;  // Pal : bag1_Pal
extern PAGfx_struct bag1; // background pointer

extern const int bag4_Info[3]; // BgMode, Width, Height
extern const unsigned short bag4_Map[768] __attribute__ ((aligned (4))) ;  // Pal : bag4_Pal
extern const unsigned char bag4_Tiles[49152] __attribute__ ((aligned (4))) ;  // Pal : bag4_Pal
extern PAGfx_struct bag4; // background pointer


// Palette files : 
extern const unsigned short pal1_Pal[135] __attribute__ ((aligned (4))) ;
extern const unsigned short bag3_Pal[154] __attribute__ ((aligned (4))) ;
extern const unsigned short bag2_Pal[163] __attribute__ ((aligned (4))) ;
extern const unsigned short bag1_Pal[74] __attribute__ ((aligned (4))) ;
extern const unsigned short bag4_Pal[252] __attribute__ ((aligned (4))) ;


#endif

