/*************
 thbg.c - game's background code go here :) callbacks for bgsetup and bgupdate are added to backgrounds structure..
*************/

#include "gfx/all_gfx.h"

#include "thgoodness.h"
#include <PA9.h>

void bg2Setup(void) {
//pff i dont even know what video modes exist atm
//	PA_SetVideoMode(0, 2);  //screen, mode
//	PA_SetVideoMode(1, 2);  //screen, mode

		PA_DeleteBg(0,1);
		PA_DeleteBg(0,2);
		PA_DeleteBg(0,3);
		PA_DeleteBg(1,1);
		PA_DeleteBg(1,2);	
		PA_DeleteBg(1,3);		
/// neeed moar layers!
//		PA_EasyBgLoad(0, 2, trees_1);	//load bottom screen bg 	
		PA_EasyBgLoad(0, 1, trees);	//load bottom screen bg
//		PA_EasyBgLoad(1, 2, trees_1);	//load bottom screen bg  
		PA_EasyBgLoad(1, 1, trees);	//load bottom screen bg 
/*
		PA_InitParallaxY(0, //screen
		0, //Parallax speed for Background 0. 0 is no parallax (will scroll independently with PA_EasyBgScrollXY)
		1024<<1, // Normal speed for Bg1
		192<<1, //   3/4 speed
		128<<1); // Half speed
		PA_InitParallaxY(1, 0, 1024<<1, 192<<1, 128<<1);	// Same thing, but for Screen 1... 	
*/
}

void bg2Update(int frame) {
	PA_BGScrollXY(1, 1, 0, -frame<<2);
	PA_BGScrollXY(0, 1, 0, -frame<<2);
//	PA_BGScrollXY(1, 2, 0, -(frame>>1));
//	PA_BGScrollXY(0, 2, 0, -(frame>>1));
}


void bg1Setup(void) {
//	return;
	PA_SetVideoMode(0, 1);  //screen, mode
	PA_SetVideoMode(1, 1);  //screen, mode

//	thDualVBLScroll(0);
	PA_LoadPAGfxRotBg(0, //screen
			  3, // background number
			  bglvl1_2, // background name in PAGfx
			  1); // wraparound !
//		PA_EasyBgLoad(0, 2, BG2);	//load bottom screen bg 	
		PA_EasyBgLoad(0, 2, bglvl1_1);	//load bottom screen bg
		
	PA_LoadPAGfxRotBg(1, //screen
			  3, // background number
			  bglvl1_2, // background name in PAGfx
			  1); // wraparound !
	thDualVBLScroll(0);
		PA_EasyBgLoad(1, 2, bglvl1_1);	//load bottom screen bg  

//		PA_EasyBgLoad(1, 2, BG2);	//load bottom screen bg 	
}


void bg1Update(int frames) {
//	PA_SetBgRot(1, 3, 134, 140, 70, 70, frames, 127);
//	PA_SetBgRot(0, 3, 128, 128, 139, 130, -frames, 100);
	PA_SetBgRot(1, 3, 134, 140, 70+((128-player.x)>>3), 70, frames, 127);
	PA_SetBgRot(0, 3, 128, 128, 139+((128-player.x)>>3), 130, -frames, 100);
	PA_BGScrollY(1, 1, -frames);
	PA_BGScrollY(0, 1, -frames);
	PA_BGScrollY(1, 2, -(frames>>1));
	PA_BGScrollY(0, 2, -(frames>>1));
}

//actual background struct
struct Background backgrounds[] = {
	{(void*)&bg1Setup,(void*)&bg1Update},
	{(void*)&bg2Setup,(void*)&bg2Update}
};
